PORTAL.Turret = object_add();
object_set_sprite(PORTAL.Turret, PORTAL.TurretS);
object_set_parent(PORTAL.Turret, Sentry);

object_event_add(PORTAL.Turret, ev_create, 0, '
    event_inherited();

    hitDamage = 8;
    dir = 0;
    lookDir = 0;
    looking = false;
    lookIndex = 1;
    normalizedDir = 0;
    hp = 100;

    noticedTarget = true;
    readyToShoot = false;
    refireTime = 3;

    team = 255;
    owner = id;
    ownerPlayer = noone;

    wiggleIndex = 1;
    wiggle = 0;

    ds_list_add(PORTAL.cubes, id);
    synced = false;
    target = noone;
    held = false;
');

object_event_add(PORTAL.Turret, ev_alarm, 0, '
    readyToShoot = true;
');

object_event_add(PORTAL.Turret, ev_alarm, 1, '
    looking = false;
');

object_event_add(PORTAL.Turret, ev_alarm, 10, '
    held = false;
');

object_event_add(PORTAL.Turret, ev_step, ev_step_begin, '');
object_event_add(PORTAL.Turret, ev_step, ev_step_normal, '
    if (image_alpha != 0 && hp < 0) {
        event_user(3);
    }

    if (image_alpha == 0 || held == true) {
        vspeed = 0;
        hspeed = 0;
        exit;
    }

    charSetAllSolids();
    with(Obstacle) {
        solid = true;
    }
    with(DropdownPlatform) {
        solid = true;
    }

    if (place_free(x, y+1)) {
        vspeed += 0.6 * global.delta_factor;

        if (vspeed > 10) {
            vspeed = 10;
        }
    } else {
        hspeed = hspeed * delta_mult(0.8);
    }

    if(!place_free(x+hspeed, y+vspeed)) {
        event_user(2);
    } else {
        x += hspeed * global.delta_factor;
        y += vspeed * global.delta_factor;
    }

    if (global.isHost == true && abs(hspeed) < 0.1 && abs(vspeed) < 0.1 && synced == false) {
        execute_string(PORTAL.SendSyncCube, id);
    }

    if (hspeed != 0 || vspeed != 0) {
        synced = false;
    }

    x -= hspeed;
    y -= vspeed;

    charUnsetSolids();
    with(DropdownPlatform) {
        solid = false;
    }
');

object_event_add(PORTAL.Turret, ev_step, ev_step_end, '
    if (image_xscale == 1) {
        normalizedDir = 0;
    } else {
        normalizedDir = 180;
    }

    if (looking == true) {
        if (abs(lookDir) > 25) {
            lookDir = median(-25, lookDir, 25);
            lookIndex *= -1;
        }
        lookDir += lookIndex * 1.5 / global.delta_factor;
    } else {
        lookDir = 0;
    }

    var targetQueue, testDist, playercheck, targetAngle;
    nearestTarget = noone;
    targetQueue = ds_priority_create();

    // Build a queue of potential targets
    with(Character) {
        testDist = distance_to_object(other);
        if(!cloak && testDist<=250) {
            ds_priority_add(targetQueue, id, testDist);
        }
    }

    with(Sentry) {
        if (team != other.team) {
            testDist = distance_to_object(other);
            if(testDist<=250) {
                ds_priority_add(targetQueue, id, testDist);
            }
        }
    }

    gunSetSolids();
    while(!nearestTarget && !ds_priority_empty(targetQueue)) {
        playercheck = ds_priority_delete_min(targetQueue);
        targetAngle = point_direction(x,y,playercheck.x,playercheck.y);
        if ((abs(normalizedDir - targetAngle) < 40) || abs(normalizedDir - targetAngle) > 320
            && playercheck.hp > 0
            && collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true) < 0
            && collision_line(x,y,playercheck.x,playercheck.y,TeamGate,true,true) < 0
            && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true) < 0
            && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true) < 0) {
                var setupGateCheck, blockedBySetupGate;
                setupGateCheck = collision_line(x,y,playercheck.x,playercheck.y,ControlPointSetupGate,true,true);
                blockedBySetupGate = true;
                if (setupGateCheck<0) { blockedBySetupGate = false; }
                else if (setupGateCheck.solid == false) { blockedBySetupGate = false; }
                if (!blockedBySetupGate) {
                    nearestTarget = playercheck;
                    dir = targetAngle;
                }
            }
    }
    ds_priority_destroy(targetQueue);

    if (!nearestTarget) {
        noticedTarget = true;
        dir = -normalizedDir;
    } else {
        if (noticedTarget == true) {
            playsound(x, y, SentryAlert);
            readyToShoot = false;
            alarm[0] = refireTime * 2 / global.delta_factor;
        }

        noticedTarget = false;
        looking = true;
        alarm[1] = 90 / global.delta_factor;
        lookDir = dir - normalizedDir;

        if(readyToShoot == true) {
            playsound(x, y, MedichaingunSnd);
            ownerPlayer = PORTAL.MapPlayerInstance;

            var shot;
            shot = createShot(x + 8 * image_xscale, y + random(10) - 10, Shot, DAMAGE_SOURCE_SENTRYTURRET, dir + random(10) - 5 + distance_to_object(nearestTarget) * image_xscale / 50 , 10 + random(1));
            shot.hitDamage = hitDamage;

            readyToShoot = false;
            alarm[0] = refireTime / global.delta_factor;
        }
    }
    gunUnsetSolids();

    if (alarm[0] > 0) {
        if (abs(wiggle) > 10) {
            wiggleIndex *= -1;
        }
        wiggle += wiggleIndex * 2 / global.delta_factor;
    } else {
        wiggle = 0;
    }
');

object_event_add(PORTAL.Turret, ev_draw, 0, '
    draw_sprite_ext(PORTAL.TurretS, 0, x, y, image_xscale, image_yscale, 0, c_white, image_alpha);
    draw_sprite_ext(PORTAL.TurretGunS, 0, x - 2 * image_xscale, y - 10, image_xscale, image_yscale, normalizedDir + dir + wiggle, c_white, image_alpha);

    draw_set_alpha(0.6);
    draw_line_width_color(x + 4 * image_xscale, y - 13, x + lengthdir_x(200, lookDir + normalizedDir), y - 13 + lengthdir_y(200, lookDir + normalizedDir), 1, c_red, c_red);
    draw_set_alpha(1);
');

object_event_add(PORTAL.Turret, ev_destroy, 0, '
    ds_list_delete(PORTAL.cubes, ds_list_find_index(PORTAL.cubes, id));
');

object_event_add(PORTAL.Turret, ev_other, ev_user1, '
    hitDamage = readProperty(other.properties, "hitDamage", REAL, hitDamage);
    image_xscale = readProperty(other.properties, "xScale", REAL, image_xscale);
');

object_event_add(PORTAL.Turret, ev_other, ev_user2, '
    really_move_contact_solid(point_direction(x,y,x+hspeed,y+vspeed), speed);
    if (!place_free(x,y+sign(vspeed))) {
        vspeed = 0;
        if (!place_free(x+hspeed,y)) {
            really_move_contact_solid(point_direction(x,y,x+hspeed,y+vspeed), speed);
            hspeed = 0;
        }
    }
    if (!place_free(x+sign(hspeed),y)) {
        hspeed *= -0.2;
        if (!place_free(x,y+vspeed)) {
            really_move_contact_solid(point_direction(x,y,x+hspeed,y+vspeed), speed);
            vspeed = 0;
        }
    }
');

object_event_add(PORTAL.Turret, ev_other, ev_user3, '
    if (image_alpha == 0) {
        exit;
    }

    // Allow the mines stickied to this autogun to drop to the floor
    with(Mine)
    {
        if(place_meeting(x,y,other.id))
            stickied = false;
    }

    if (global.isHost == true) {
        image_alpha = 0;
        execute_string(PORTAL.SendSyncCube, id);
    }
');

object_event_add(PORTAL.Turret, ev_collision, PORTAL.Portal, '
    execute_string(PORTAL.TeleportProjectile, id, other.id, true);
');

object_event_add(PORTAL.Turret, ev_collision, PORTAL.Cube, '
    if (other.speed > 5 && global.isHost == true) {
        event_user(3);
    }
');

object_event_add(PORTAL.Turret, ev_collision, PitFall, '
    event_user(3);
');

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PORTAL.RocketTurret = object_add();
object_set_depth(PORTAL.RocketTurret, -1);
object_set_sprite(PORTAL.RocketTurret, SentryMaskS);
object_set_parent(PORTAL.RocketTurret, Obstacle); // The rocket turret can't be damaged.

object_event_add(PORTAL.RocketTurret, ev_create, 0, '
    // Align with mappixels.
    y += 2;

    rotating = false;
    rotateindex = 0;
    shooting = false;
    dir = 0;
    points = ds_list_create();
    updated = false;
    previousAngle = 0;
    locked = false;

    xoffset = 2;
    yoffset = 2;
    refireTime = 60;
    lockTime = 20;
    shootTime = 20;

    readyToShoot=false;
    noticedTarget=true;
    nearestTarget = noone;
    hitDamage = 40;
    explosionDamage = 30;

    team = 255;
    owner = id;

    alarm[0] = refireTime / global.delta_factor;
    alarm[1] = 1;
');

object_event_add(PORTAL.RocketTurret, ev_alarm, 0, '
    readyToShoot = true;
    locked = false;
');

object_event_add(PORTAL.RocketTurret, ev_alarm, 1, '
    event_user(2);
');

object_event_add(PORTAL.RocketTurret, ev_alarm, 2, '
    locked = true;
    alarm[3] = shootTime / global.delta_factor;
    playsound(x, y, SentryAlert);
');

object_event_add(PORTAL.RocketTurret, ev_alarm, 3, '
    playsound(x, y, RocketSnd);
    ownerPlayer = PORTAL.MapPlayerInstance;
    var oid;
    oid = createShot(x+lengthdir_x(20, dir),y+lengthdir_y(20, dir), Rocket, DAMAGE_SOURCE_GENERATOR_EXPLOSION, dir, 13);
    oid.hitDamage = hitDamage;
    oid.explosionDamage = explosionDamage;
    oid.gun = id;

    shooting = true;
    readyToShoot = false;
    alarm[0] = refireTime / global.delta_factor;
');

object_event_add(PORTAL.RocketTurret, ev_draw, 0, '
    if (image_xscale == 1) {
        normalizedDir = 0;
    } else {
        normalizedDir = 180;
    }

    if (locked == false) {
        var targetQueue, testDist, playercheck, targetAngle;
        nearestTarget = noone;
        targetQueue = ds_priority_create();

        // Build a queue of potential targets
        with(Character) {
            testDist = distance_to_object(other);
            if(!cloak && testDist<=800) {
                ds_priority_add(targetQueue, id, testDist);
            }
        }

        with(Sentry) {
            if (team != other.team) {
                testDist = distance_to_object(other);
                if(testDist<=800) {
                    ds_priority_add(targetQueue, id, testDist);
                }
            }
        }

        gunSetSolids();
        while(!nearestTarget && !ds_priority_empty(targetQueue)) {
            playercheck = ds_priority_delete_min(targetQueue);
            targetAngle = point_direction(x,y,playercheck.x,playercheck.y);
            if (playercheck.hp > 0
                && collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true) < 0
                && collision_line(x,y,playercheck.x,playercheck.y,TeamGate,true,true) < 0
                && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true) < 0
                && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true) < 0) {
                    var setupGateCheck, blockedBySetupGate;
                    setupGateCheck = collision_line(x,y,playercheck.x,playercheck.y,ControlPointSetupGate,true,true);
                    blockedBySetupGate = true;
                    if (setupGateCheck<0) { blockedBySetupGate = false; }
                    else if (setupGateCheck.solid == false) { blockedBySetupGate = false; }
                    if (!blockedBySetupGate) {
                        nearestTarget = playercheck;
                        dir = targetAngle;
                    }
                }
        }
        ds_priority_destroy(targetQueue);

        if (!nearestTarget) {
            noticedTarget = true;
            dir = -normalizedDir;
            previousAngle = 0;
            alarm[2] = -1;

            if (updated == false) {
                updated = true;
                event_user(2);
            }
        } else {
            if(nearestTarget.x < x && image_xscale == 1) {
                rotating=true;
            } else if(nearestTarget.x > x && image_xscale == -1) {
                rotating=true;
            }

            event_user(2);
            updated = false;

            if(readyToShoot == true && rotating == false) {
                if (alarm[2] < 0 || abs(previousAngle - targetAngle) > 0.3) {
                    alarm[2] = lockTime / global.delta_factor;
                }
            } else {
                alarm[2] = -1;
            }

            if (global.run_virtual_ticks == true) {
                previousAngle = targetAngle;
            }
        }

        gunUnsetSolids();
    }

    if(rotating == true) {
        rotateindex += 0.3 * global.delta_factor;
        if(rotateindex >= 4) {
            image_xscale = -image_xscale;
            rotating = false;
            rotateindex = 0;
        }
    }
');

object_event_add(PORTAL.RocketTurret, ev_draw, 0, '
    var xr, yr, i;
    xr = round(x);
    yr = round(y);

    if (rotating == false) {
        draw_set_alpha(0.6);
        for (i = 0; i < ds_list_size(points); i += 4) {
            draw_line_width_color(ds_list_find_value(points, i), ds_list_find_value(points, i + 1), ds_list_find_value(points, i + 2), ds_list_find_value(points, i + 3), 1, c_aqua, c_aqua);
        }
        draw_set_alpha(1);
    }

    draw_sprite_ext(PORTAL.RocketTurretBaseS, 11, xr, yr, 1, image_yscale, image_angle, c_white, 1);
    if (rotating == true) {
        draw_sprite_ext(PORTAL.RocketTurretRotateS, round(rotateindex), xr, yr, image_xscale, image_yscale, 0, c_white, 1);
    } else {
        draw_sprite_ext(PORTAL.RocketTurretS, shooting, round(x + xoffset * image_xscale), round(y + yoffset), image_xscale, image_yscale, dir + normalizedDir, c_white, 1);
    }

    shooting = false;
');

object_event_add(PORTAL.RocketTurret, ev_destroy, 0, '
    ds_list_destroy(points);
');

object_event_add(PORTAL.RocketTurret, ev_other, ev_user1, '
    hitDamage = readProperty(other.properties, "hitDamage", REAL, hitDamage);
    explosionDamage = readProperty(other.properties, "explosionDamage", REAL, explosionDamage);
    image_xscale = readProperty(other.properties, "xScale", REAL, image_xscale);
');

object_event_add(PORTAL.RocketTurret, ev_other, ev_user2, '
    ds_list_clear(points);
    gunSetSolids();

    var i, originalX, leftmostX, x1, y1, d, j, max, new;
    originalX = ds_map_create();
    max = 3;

    d = dir;
    x1 = x;
    y1 = y;

    leftmostX = -8008135;

    for (i = 0; i < ds_list_size(PORTAL.ROCKETCOLLIDERS); i += 1) {
        if (!solid) {
            ds_map_add(originalX, id, x);
            x += leftmostX - bbox_right - 10;
        }
    }

    for (j = 0; j < max; j += 1) {
        distance = execute_string(PORTAL.Raycast, PORTAL.ROCKETCOLLIDERS, 2000, x1, y1, x1 + lengthdir_x(2000, d), y1 + lengthdir_y(2000, d));

        if (distance > 1) {
            ds_list_add(points, x1);
            ds_list_add(points, y1);
            ds_list_add(points, x1 + lengthdir_x(distance, d));
            ds_list_add(points, y1 + lengthdir_y(distance, d));
        }

        new = false;

        if (hitInstance != noone) {
            if (hitInstance.object_index == PORTAL.Portal) {
                if (instance_exists(hitInstance.pair) == true) {
                    d = 180 + hitInstance.image_angle - d + hitInstance.pair.image_angle;
                    x1 = hitInstance.pair.x;
                    y1 = hitInstance.pair.y;

                    // Remove the portal so we dont collide with it again.
                    with(hitInstance.pair) {
                        ds_map_add(originalX, id, x);
                        x += leftmostX - bbox_right - 10;
                    }

                    new = true;
                }
            }
        }

        if (new == false) {
            break;
        }
    }

    var key, origX;
    for(key = ds_map_find_first(originalX); key; key = ds_map_find_next(originalX, key)) {
        origX = ds_map_find_value(originalX, key);
        with(key) {
            x = origX;
        }
    }

    ds_map_destroy(originalX);
    gunUnsetSolids();
');
